
/**
 * Write a description of class GhostStory here.
 *
 * @author (your name)
 * @version (a version number or a date)
 */

import ecs100.*;

public class GhostStory
{

    public void moveOneGhost() {
        Ghost ghost = new Ghost(100, 100, 50, 50);
        
        ghost.lookRight();
        /*for(int count = 0; count < 10; count++){ //count ++ or count = count + 1
            ghost.move();
        }*/
        int count = 0;
        while(count < 10){
            ghost.move();
            count++; // OR count = count + 1;
        }
        
    }

    public void moveTwoGhosts() {
        Ghost gSmall = new Ghost(100, 100, 25, 25);
        Ghost gLarge = new Ghost(100, 200, 50, 50); 
        
        gSmall.move();
        gSmall.lookStraight();
        gSmall.setScared(true);
        
        gLarge.move();
        
    }
    
  
    public void moveTwoGhostsUp() {
        Ghost g1 = new Ghost(100,400,50,50,Ghost.POKEY, Ghost.UP);
        
        double random = 100 + Math.random()*600; //Random number between 100 - 700
        
        Ghost g2 = new Ghost(200,random,50,50,Ghost.INKY, Ghost.UP);
        
        //
        // Find the Ghost closer to the top
        /*if(g1.getTop()<g2.getTop()){
            this.moveGhostToTop(g1);
        }
        else{
            this.moveGhostToTop(g2);
        }
        // Move it to top*/
        Ghost closerGhost = this.closestToTop(g1, g2);
        this.moveGhostToTop(closerGhost);
                
    }
    
    //Find the Ghost closest to the top
    public Ghost closestToTop(Ghost g1, Ghost g2)
    {
        if(g1.getTop()<g2.getTop()){
            return g1;
        }
        else{
            return g2;            
        }
    
    }
    
    public void moveGhostToTop(Ghost ghost)
    {
        ghost.lookUp();
        while(ghost.getTop()>0){
            ghost.move();
        }
    }

    public void moveTwoGhostsMethods() {
        Ghost g1 = new Ghost(100,200,50,50);
        Ghost g2 = new Ghost(200,300,50,50, "Inky"); 

        g2.lookStraight();

        this.moveSquare(g1,10); 
        this.moveSquare(g2,5); 

    }

    public void moveTwoGhostsDistance() {
        Ghost g1 = new Ghost(100,200,50,50);
        Ghost g2 = new Ghost(400,200,50,50, "Pinky");

        g1.lookRight();

        while(this.getDistance(g1,g2) > 50) {
            g1.move();
        }  

        g2.setScared(true);
        g2.lookRight();
        g2.move();
    }

    public void moveSquare(Ghost g, int count) {
        g.lookRight();
        this.moveSteps(g, count);
        g.lookDown();
        this.moveSteps(g, count);
        g.lookLeft();
        this.moveSteps(g, count);
        g.lookUp();
        this.moveSteps(g, count);
        g.lookStraight();
    }

    //I did not manage to do this in lecture, but this method makes the code cleaner.
    public void moveSteps(Ghost ghost, int count) {
        int i = 0;
        while(i<count) {
            ghost.move();
            i=i+1;
        }
    }

    //Using pythagora
    public double getDistance(Ghost g1, Ghost g2) {
        Double a2 = (g1.getMiddleX() - g2.getMiddleX()) * (g1.getMiddleX() - g2.getMiddleX());
        Double b2 = (g1.getMiddleY() - g2.getMiddleY()) * (g1.getMiddleY() - g2.getMiddleY());

        return Math.sqrt(a2 + b2);
    }

    public void setupGUI() {
        UI.addButton("Move One", this::moveOneGhost);
        UI.addButton("Move Two", this::moveTwoGhosts);
        UI.addButton("Move Two Up", this::moveTwoGhostsUp);
        UI.addButton("Move Two Methods", this::moveTwoGhostsMethods);
        UI.addButton("Move Two Distance", this::moveTwoGhostsDistance);
        UI.addButton("Clear", UI::clearGraphics);
    }

    public static void main(String[] args) {
        new GhostStory().setupGUI();
    }
}
